package com.zd.chemical.mapper;

import java.util.List;
import java.util.Map;

import com.zd.chemical.domain.HxpUserecord;
import com.zd.chemical.domain.vo.AioUserecordVo;
import com.zd.chemical.domain.vo.HxpUserecordDetailVo;
import com.zd.chemical.domain.vo.HxpUserecordSearch;
import com.zd.chemical.domain.vo.HxpUserecordVo;
import org.apache.ibatis.annotations.Param;

/**
 * 化学品使用记录Mapper接口
 *
 * @author liubo
 * @date 2022-06-18
 */
public interface HxpUserecordMapper
{
    /**
     * 查询化学品使用记录
     *
     * @param id 化学品使用记录主键
     * @return 化学品使用记录
     */
    public HxpUserecord selectHxpUserecordById(Long id);

    /**
     * 查询化学品使用记录列表
     *
     * @param hxpUserecord 化学品使用记录
     * @return 化学品使用记录集合
     */
    public List<HxpUserecord> selectHxpUserecordList(HxpUserecord hxpUserecord);

    /**
     * 查询化学品使用记录列表
     *
     * @param hxpUserecordSearch 化学品使用记录
     * @return 化学品使用记录集合
     */
    public List<HxpUserecordVo> getHxpUserecordList(HxpUserecordSearch hxpUserecordSearch);

    /**
     * 新增化学品使用记录
     *
     * @param hxpUserecord 化学品使用记录
     * @return 结果
     */
    public int insertHxpUserecord(HxpUserecord hxpUserecord);

    /**
     * 修改化学品使用记录
     *
     * @param hxpUserecord 化学品使用记录
     * @return 结果
     */
    public int updateHxpUserecord(HxpUserecord hxpUserecord);

    /**
     * 删除化学品使用记录
     *
     * @param id 化学品使用记录主键
     * @return 结果
     */
    public int deleteHxpUserecordById(Long id);

    /**
     * 批量删除化学品使用记录
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteHxpUserecordByIds(Long[] ids);

    List<AioUserecordVo> queryRecordList(AioUserecordVo aioUserecordVo);

    HxpUserecord selectByStockId(Long stockId);

    Map<String, Object> selectSubInfoById(Long subId);

    int selectIsAdminOrSafeUser(@Param("subId") Long subId, @Param("userId") Long userId);

    List<HxpUserecord> selectByOvertime();

    int updateUserecordOvertimeByIds(@Param("list") List<Long> recordIds);

    HxpUserecordDetailVo queryDetailById(Long id);
}
